diff --git a/src/backend/access/rmgrdesc/xlogdesc.c b/src/backend/access/rmgrdesc/xlogdesc.c
new file mode 100644
index 5f07eb1..2d60d70
*** a/src/backend/access/rmgrdesc/xlogdesc.c
--- b/src/backend/access/rmgrdesc/xlogdesc.c
*************** xlog_desc(StringInfo buf, XLogReaderStat
*** 44,58 ****
  		CheckPoint *checkpoint = (CheckPoint *) rec;
  
  		appendStringInfo(buf, "redo %X/%X; "
! 						 "tli %u; prev tli %u; fpw %s; xid %u:%u; oid %u; multi %u; offset %u; "
! 						 "oldest xid %u in DB %u; oldest multi %u in DB %u; "
! 						 "oldest/newest commit timestamp xid: %u/%u; "
! 						 "oldest running xid %u; %s",
  				(uint32) (checkpoint->redo >> 32), (uint32) checkpoint->redo,
  						 checkpoint->ThisTimeLineID,
  						 checkpoint->PrevTimeLineID,
  						 checkpoint->fullPageWrites ? "true" : "false",
! 						 checkpoint->nextXidEpoch, checkpoint->nextXid,
  						 checkpoint->nextOid,
  						 checkpoint->nextMulti,
  						 checkpoint->nextMultiOffset,
--- 44,58 ----
  		CheckPoint *checkpoint = (CheckPoint *) rec;
  
  		appendStringInfo(buf, "redo %X/%X; "
! 						 "tli %u; prev tli %u; fpw %s; xid " XID_FMT "; oid %u; multi " XID_FMT "; offset " INT64_FORMAT "; "
! 						 "oldest xid " XID_FMT " in DB %u; oldest multi " XID_FMT " in DB %u; "
! 						 "oldest/newest commit timestamp xid: " XID_FMT "/" XID_FMT "; "
! 						 "oldest running xid " XID_FMT "; %s",
  				(uint32) (checkpoint->redo >> 32), (uint32) checkpoint->redo,
  						 checkpoint->ThisTimeLineID,
  						 checkpoint->PrevTimeLineID,
  						 checkpoint->fullPageWrites ? "true" : "false",
! 						 checkpoint->nextXid,
  						 checkpoint->nextOid,
  						 checkpoint->nextMulti,
  						 checkpoint->nextMultiOffset,
diff --git a/src/backend/access/transam/clog.c b/src/backend/access/transam/clog.c
new file mode 100644
index bece575..6136ffc
*** a/src/backend/access/transam/clog.c
--- b/src/backend/access/transam/clog.c
*************** static SlruCtlData ClogCtlData;
*** 80,93 ****
  #define ClogCtl (&ClogCtlData)
  
  
! static int	ZeroCLOGPage(int pageno, bool writeXlog);
! static bool CLOGPagePrecedes(int page1, int page2);
! static void WriteZeroPageXlogRec(int pageno);
! static void WriteTruncateXlogRec(int pageno, TransactionId oldestXact,
  					 Oid oldestXidDb);
  static void TransactionIdSetPageStatus(TransactionId xid, int nsubxids,
  						   TransactionId *subxids, XidStatus status,
! 						   XLogRecPtr lsn, int pageno);
  static void TransactionIdSetStatusBit(TransactionId xid, XidStatus status,
  						  XLogRecPtr lsn, int slotno);
  static void set_status_by_pages(int nsubxids, TransactionId *subxids,
--- 80,92 ----
  #define ClogCtl (&ClogCtlData)
  
  
! static int	ZeroCLOGPage(int64 pageno, bool writeXlog);
! static void WriteZeroPageXlogRec(int64 pageno);
! static void WriteTruncateXlogRec(int64 pageno, TransactionId oldestXact,
  					 Oid oldestXidDb);
  static void TransactionIdSetPageStatus(TransactionId xid, int nsubxids,
  						   TransactionId *subxids, XidStatus status,
! 						   XLogRecPtr lsn, int64 pageno);
  static void TransactionIdSetStatusBit(TransactionId xid, XidStatus status,
  						  XLogRecPtr lsn, int slotno);
  static void set_status_by_pages(int nsubxids, TransactionId *subxids,
*************** void
*** 149,155 ****
  TransactionIdSetTreeStatus(TransactionId xid, int nsubxids,
  					TransactionId *subxids, XidStatus status, XLogRecPtr lsn)
  {
! 	int			pageno = TransactionIdToPage(xid);		/* get page of parent */
  	int			i;
  
  	Assert(status == TRANSACTION_STATUS_COMMITTED ||
--- 148,154 ----
  TransactionIdSetTreeStatus(TransactionId xid, int nsubxids,
  					TransactionId *subxids, XidStatus status, XLogRecPtr lsn)
  {
! 	int64		pageno = TransactionIdToPage(xid);		/* get page of parent */
  	int			i;
  
  	Assert(status == TRANSACTION_STATUS_COMMITTED ||
*************** static void
*** 223,229 ****
  set_status_by_pages(int nsubxids, TransactionId *subxids,
  					XidStatus status, XLogRecPtr lsn)
  {
! 	int			pageno = TransactionIdToPage(subxids[0]);
  	int			offset = 0;
  	int			i = 0;
  
--- 222,228 ----
  set_status_by_pages(int nsubxids, TransactionId *subxids,
  					XidStatus status, XLogRecPtr lsn)
  {
! 	int64		pageno = TransactionIdToPage(subxids[0]);
  	int			offset = 0;
  	int			i = 0;
  
*************** set_status_by_pages(int nsubxids, Transa
*** 254,260 ****
  static void
  TransactionIdSetPageStatus(TransactionId xid, int nsubxids,
  						   TransactionId *subxids, XidStatus status,
! 						   XLogRecPtr lsn, int pageno)
  {
  	int			slotno;
  	int			i;
--- 253,259 ----
  static void
  TransactionIdSetPageStatus(TransactionId xid, int nsubxids,
  						   TransactionId *subxids, XidStatus status,
! 						   XLogRecPtr lsn, int64 pageno)
  {
  	int			slotno;
  	int			i;
*************** TransactionIdSetStatusBit(TransactionId 
*** 392,398 ****
  XidStatus
  TransactionIdGetStatus(TransactionId xid, XLogRecPtr *lsn)
  {
! 	int			pageno = TransactionIdToPage(xid);
  	int			byteno = TransactionIdToByte(xid);
  	int			bshift = TransactionIdToBIndex(xid) * CLOG_BITS_PER_XACT;
  	int			slotno;
--- 391,397 ----
  XidStatus
  TransactionIdGetStatus(TransactionId xid, XLogRecPtr *lsn)
  {
! 	int64		pageno = TransactionIdToPage(xid);
  	int			byteno = TransactionIdToByte(xid);
  	int			bshift = TransactionIdToBIndex(xid) * CLOG_BITS_PER_XACT;
  	int			slotno;
*************** CLOGShmemSize(void)
*** 449,455 ****
  void
  CLOGShmemInit(void)
  {
- 	ClogCtl->PagePrecedes = CLOGPagePrecedes;
  	SimpleLruInit(ClogCtl, "clog", CLOGShmemBuffers(), CLOG_LSNS_PER_PAGE,
  				  CLogControlLock, "pg_xact", LWTRANCHE_CLOG_BUFFERS);
  }
--- 448,453 ----
*************** BootStrapCLOG(void)
*** 487,493 ****
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! ZeroCLOGPage(int pageno, bool writeXlog)
  {
  	int			slotno;
  
--- 485,491 ----
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! ZeroCLOGPage(int64 pageno, bool writeXlog)
  {
  	int			slotno;
  
*************** void
*** 507,513 ****
  StartupCLOG(void)
  {
  	TransactionId xid = ShmemVariableCache->nextXid;
! 	int			pageno = TransactionIdToPage(xid);
  
  	LWLockAcquire(CLogControlLock, LW_EXCLUSIVE);
  
--- 505,511 ----
  StartupCLOG(void)
  {
  	TransactionId xid = ShmemVariableCache->nextXid;
! 	int64		pageno = TransactionIdToPage(xid);
  
  	LWLockAcquire(CLogControlLock, LW_EXCLUSIVE);
  
*************** void
*** 526,532 ****
  TrimCLOG(void)
  {
  	TransactionId xid = ShmemVariableCache->nextXid;
! 	int			pageno = TransactionIdToPage(xid);
  
  	LWLockAcquire(CLogControlLock, LW_EXCLUSIVE);
  
--- 524,530 ----
  TrimCLOG(void)
  {
  	TransactionId xid = ShmemVariableCache->nextXid;
! 	int64		pageno = TransactionIdToPage(xid);
  
  	LWLockAcquire(CLogControlLock, LW_EXCLUSIVE);
  
*************** CheckPointCLOG(void)
*** 618,624 ****
  void
  ExtendCLOG(TransactionId newestXact)
  {
! 	int			pageno;
  
  	/*
  	 * No work except at first XID of a page.  But beware: just after
--- 616,622 ----
  void
  ExtendCLOG(TransactionId newestXact)
  {
! 	int64		pageno;
  
  	/*
  	 * No work except at first XID of a page.  But beware: just after
*************** ExtendCLOG(TransactionId newestXact)
*** 657,663 ****
  void
  TruncateCLOG(TransactionId oldestXact, Oid oldestxid_datoid)
  {
! 	int			cutoffPage;
  
  	/*
  	 * The cutoff point is the start of the segment containing oldestXact. We
--- 655,661 ----
  void
  TruncateCLOG(TransactionId oldestXact, Oid oldestxid_datoid)
  {
! 	int64		cutoffPage;
  
  	/*
  	 * The cutoff point is the start of the segment containing oldestXact. We
*************** TruncateCLOG(TransactionId oldestXact, O
*** 694,732 ****
  	SimpleLruTruncate(ClogCtl, cutoffPage);
  }
  
- 
- /*
-  * Decide which of two CLOG page numbers is "older" for truncation purposes.
-  *
-  * We need to use comparison of TransactionIds here in order to do the right
-  * thing with wraparound XID arithmetic.  However, if we are asked about
-  * page number zero, we don't want to hand InvalidTransactionId to
-  * TransactionIdPrecedes: it'll get weird about permanent xact IDs.  So,
-  * offset both xids by FirstNormalTransactionId to avoid that.
-  */
- static bool
- CLOGPagePrecedes(int page1, int page2)
- {
- 	TransactionId xid1;
- 	TransactionId xid2;
- 
- 	xid1 = ((TransactionId) page1) * CLOG_XACTS_PER_PAGE;
- 	xid1 += FirstNormalTransactionId;
- 	xid2 = ((TransactionId) page2) * CLOG_XACTS_PER_PAGE;
- 	xid2 += FirstNormalTransactionId;
- 
- 	return TransactionIdPrecedes(xid1, xid2);
- }
- 
- 
  /*
   * Write a ZEROPAGE xlog record
   */
  static void
! WriteZeroPageXlogRec(int pageno)
  {
  	XLogBeginInsert();
! 	XLogRegisterData((char *) (&pageno), sizeof(int));
  	(void) XLogInsert(RM_CLOG_ID, CLOG_ZEROPAGE);
  }
  
--- 692,705 ----
  	SimpleLruTruncate(ClogCtl, cutoffPage);
  }
  
  /*
   * Write a ZEROPAGE xlog record
   */
  static void
! WriteZeroPageXlogRec(int64 pageno)
  {
  	XLogBeginInsert();
! 	XLogRegisterData((char *) (&pageno), sizeof(int64));
  	(void) XLogInsert(RM_CLOG_ID, CLOG_ZEROPAGE);
  }
  
*************** WriteZeroPageXlogRec(int pageno)
*** 737,743 ****
   * in TruncateCLOG().
   */
  static void
! WriteTruncateXlogRec(int pageno, TransactionId oldestXact, Oid oldestXactDb)
  {
  	XLogRecPtr	recptr;
  	xl_clog_truncate xlrec;
--- 710,716 ----
   * in TruncateCLOG().
   */
  static void
! WriteTruncateXlogRec(int64 pageno, TransactionId oldestXact, Oid oldestXactDb)
  {
  	XLogRecPtr	recptr;
  	xl_clog_truncate xlrec;
*************** clog_redo(XLogReaderState *record)
*** 765,774 ****
  
  	if (info == CLOG_ZEROPAGE)
  	{
! 		int			pageno;
  		int			slotno;
  
! 		memcpy(&pageno, XLogRecGetData(record), sizeof(int));
  
  		LWLockAcquire(CLogControlLock, LW_EXCLUSIVE);
  
--- 738,747 ----
  
  	if (info == CLOG_ZEROPAGE)
  	{
! 		int64		pageno;
  		int			slotno;
  
! 		memcpy(&pageno, XLogRecGetData(record), sizeof(int64));
  
  		LWLockAcquire(CLogControlLock, LW_EXCLUSIVE);
  
diff --git a/src/backend/access/transam/commit_ts.c b/src/backend/access/transam/commit_ts.c
new file mode 100644
index 7646c23..5e8e249
*** a/src/backend/access/transam/commit_ts.c
--- b/src/backend/access/transam/commit_ts.c
*************** bool		track_commit_timestamp;
*** 104,119 ****
  
  static void SetXidCommitTsInPage(TransactionId xid, int nsubxids,
  					 TransactionId *subxids, TimestampTz ts,
! 					 RepOriginId nodeid, int pageno);
  static void TransactionIdSetCommitTs(TransactionId xid, TimestampTz ts,
  						 RepOriginId nodeid, int slotno);
  static void error_commit_ts_disabled(void);
! static int	ZeroCommitTsPage(int pageno, bool writeXlog);
! static bool CommitTsPagePrecedes(int page1, int page2);
  static void ActivateCommitTs(void);
  static void DeactivateCommitTs(void);
! static void WriteZeroPageXlogRec(int pageno);
! static void WriteTruncateXlogRec(int pageno, TransactionId oldestXid);
  static void WriteSetTimestampXlogRec(TransactionId mainxid, int nsubxids,
  						 TransactionId *subxids, TimestampTz timestamp,
  						 RepOriginId nodeid);
--- 104,118 ----
  
  static void SetXidCommitTsInPage(TransactionId xid, int nsubxids,
  					 TransactionId *subxids, TimestampTz ts,
! 					 RepOriginId nodeid, int64 pageno);
  static void TransactionIdSetCommitTs(TransactionId xid, TimestampTz ts,
  						 RepOriginId nodeid, int slotno);
  static void error_commit_ts_disabled(void);
! static int	ZeroCommitTsPage(int64 pageno, bool writeXlog);
  static void ActivateCommitTs(void);
  static void DeactivateCommitTs(void);
! static void WriteZeroPageXlogRec(int64 pageno);
! static void WriteTruncateXlogRec(int64 pageno, TransactionId oldestXid);
  static void WriteSetTimestampXlogRec(TransactionId mainxid, int nsubxids,
  						 TransactionId *subxids, TimestampTz timestamp,
  						 RepOriginId nodeid);
*************** TransactionTreeSetCommitTsData(Transacti
*** 186,192 ****
  	 */
  	for (i = 0, headxid = xid;;)
  	{
! 		int			pageno = TransactionIdToCTsPage(headxid);
  		int			j;
  
  		for (j = i; j < nsubxids; j++)
--- 185,191 ----
  	 */
  	for (i = 0, headxid = xid;;)
  	{
! 		int64		pageno = TransactionIdToCTsPage(headxid);
  		int			j;
  
  		for (j = i; j < nsubxids; j++)
*************** TransactionTreeSetCommitTsData(Transacti
*** 230,236 ****
  static void
  SetXidCommitTsInPage(TransactionId xid, int nsubxids,
  					 TransactionId *subxids, TimestampTz ts,
! 					 RepOriginId nodeid, int pageno)
  {
  	int			slotno;
  	int			i;
--- 229,235 ----
  static void
  SetXidCommitTsInPage(TransactionId xid, int nsubxids,
  					 TransactionId *subxids, TimestampTz ts,
! 					 RepOriginId nodeid, int64 pageno)
  {
  	int			slotno;
  	int			i;
*************** bool
*** 282,288 ****
  TransactionIdGetCommitTsData(TransactionId xid, TimestampTz *ts,
  							 RepOriginId *nodeid)
  {
! 	int			pageno = TransactionIdToCTsPage(xid);
  	int			entryno = TransactionIdToCTsEntry(xid);
  	int			slotno;
  	CommitTimestampEntry entry;
--- 281,287 ----
  TransactionIdGetCommitTsData(TransactionId xid, TimestampTz *ts,
  							 RepOriginId *nodeid)
  {
! 	int64		pageno = TransactionIdToCTsPage(xid);
  	int			entryno = TransactionIdToCTsEntry(xid);
  	int			slotno;
  	CommitTimestampEntry entry;
*************** TransactionIdGetCommitTsData(Transaction
*** 292,298 ****
  	if (!TransactionIdIsValid(xid))
  		ereport(ERROR,
  				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
! 		errmsg("cannot retrieve commit timestamp for transaction %u", xid)));
  	else if (!TransactionIdIsNormal(xid))
  	{
  		/* frozen and bootstrap xids are always committed far in the past */
--- 291,297 ----
  	if (!TransactionIdIsValid(xid))
  		ereport(ERROR,
  				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
! 		errmsg("cannot retrieve commit timestamp for transaction " XID_FMT, xid)));
  	else if (!TransactionIdIsNormal(xid))
  	{
  		/* frozen and bootstrap xids are always committed far in the past */
*************** error_commit_ts_disabled(void)
*** 404,410 ****
  Datum
  pg_xact_commit_timestamp(PG_FUNCTION_ARGS)
  {
! 	TransactionId xid = PG_GETARG_UINT32(0);
  	TimestampTz ts;
  	bool		found;
  
--- 403,409 ----
  Datum
  pg_xact_commit_timestamp(PG_FUNCTION_ARGS)
  {
! 	TransactionId xid = PG_GETARG_TRANSACTIONID(0);
  	TimestampTz ts;
  	bool		found;
  
*************** CommitTsShmemInit(void)
*** 491,497 ****
  {
  	bool		found;
  
- 	CommitTsCtl->PagePrecedes = CommitTsPagePrecedes;
  	SimpleLruInit(CommitTsCtl, "commit_timestamp", CommitTsShmemBuffers(), 0,
  				  CommitTsControlLock, "pg_commit_ts",
  				  LWTRANCHE_COMMITTS_BUFFERS);
--- 490,495 ----
*************** BootStrapCommitTs(void)
*** 539,545 ****
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! ZeroCommitTsPage(int pageno, bool writeXlog)
  {
  	int			slotno;
  
--- 537,543 ----
   * Control lock must be held at entry, and will be held at exit.
   */
  static int
! ZeroCommitTsPage(int64 pageno, bool writeXlog)
  {
  	int			slotno;
  
*************** static void
*** 633,639 ****
  ActivateCommitTs(void)
  {
  	TransactionId xid;
! 	int			pageno;
  
  	/* If we've done this already, there's nothing to do */
  	LWLockAcquire(CommitTsLock, LW_EXCLUSIVE);
--- 631,637 ----
  ActivateCommitTs(void)
  {
  	TransactionId xid;
! 	int64		pageno;
  
  	/* If we've done this already, there's nothing to do */
  	LWLockAcquire(CommitTsLock, LW_EXCLUSIVE);
*************** CheckPointCommitTs(void)
*** 784,790 ****
  void
  ExtendCommitTs(TransactionId newestXact)
  {
! 	int			pageno;
  
  	/*
  	 * Nothing to do if module not enabled.  Note we do an unlocked read of
--- 782,788 ----
  void
  ExtendCommitTs(TransactionId newestXact)
  {
! 	int64		pageno;
  
  	/*
  	 * Nothing to do if module not enabled.  Note we do an unlocked read of
*************** ExtendCommitTs(TransactionId newestXact)
*** 822,828 ****
  void
  TruncateCommitTs(TransactionId oldestXact)
  {
! 	int			cutoffPage;
  
  	/*
  	 * The cutoff point is the start of the segment containing oldestXact. We
--- 820,826 ----
  void
  TruncateCommitTs(TransactionId oldestXact)
  {
! 	int64		cutoffPage;
  
  	/*
  	 * The cutoff point is the start of the segment containing oldestXact. We
*************** AdvanceOldestCommitTsXid(TransactionId o
*** 884,920 ****
  
  
  /*
-  * Decide which of two CLOG page numbers is "older" for truncation purposes.
-  *
-  * We need to use comparison of TransactionIds here in order to do the right
-  * thing with wraparound XID arithmetic.  However, if we are asked about
-  * page number zero, we don't want to hand InvalidTransactionId to
-  * TransactionIdPrecedes: it'll get weird about permanent xact IDs.  So,
-  * offset both xids by FirstNormalTransactionId to avoid that.
-  */
- static bool
- CommitTsPagePrecedes(int page1, int page2)
- {
- 	TransactionId xid1;
- 	TransactionId xid2;
- 
- 	xid1 = ((TransactionId) page1) * COMMIT_TS_XACTS_PER_PAGE;
- 	xid1 += FirstNormalTransactionId;
- 	xid2 = ((TransactionId) page2) * COMMIT_TS_XACTS_PER_PAGE;
- 	xid2 += FirstNormalTransactionId;
- 
- 	return TransactionIdPrecedes(xid1, xid2);
- }
- 
- 
- /*
   * Write a ZEROPAGE xlog record
   */
  static void
! WriteZeroPageXlogRec(int pageno)
  {
  	XLogBeginInsert();
! 	XLogRegisterData((char *) (&pageno), sizeof(int));
  	(void) XLogInsert(RM_COMMIT_TS_ID, COMMIT_TS_ZEROPAGE);
  }
  
--- 882,894 ----
  
  
  /*
   * Write a ZEROPAGE xlog record
   */
  static void
! WriteZeroPageXlogRec(int64 pageno)
  {
  	XLogBeginInsert();
! 	XLogRegisterData((char *) (&pageno), sizeof(int64));
  	(void) XLogInsert(RM_COMMIT_TS_ID, COMMIT_TS_ZEROPAGE);
  }
  
*************** WriteZeroPageXlogRec(int pageno)
*** 922,928 ****
   * Write a TRUNCATE xlog record
   */
  static void
! WriteTruncateXlogRec(int pageno, TransactionId oldestXid)
  {
  	xl_commit_ts_truncate xlrec;
  
--- 896,902 ----
   * Write a TRUNCATE xlog record
   */
  static void
! WriteTruncateXlogRec(int64 pageno, TransactionId oldestXid)
  {
  	xl_commit_ts_truncate xlrec;
  
*************** commit_ts_redo(XLogReaderState *record)
*** 969,978 ****
  
  	if (info == COMMIT_TS_ZEROPAGE)
  	{
! 		int			pageno;
  		int			slotno;
  
! 		memcpy(&pageno, XLogRecGetData(record), sizeof(int));
  
  		LWLockAcquire(CommitTsControlLock, LW_EXCLUSIVE);
  
--- 943,952 ----
  
  	if (info == COMMIT_TS_ZEROPAGE)
  	{
! 		int64		pageno;
  		int			slotno;
  
! 		memcpy(&pageno, XLogRecGetData(record), sizeof(int64));
  
  		LWLockAcquire(CommitTsControlLock, LW_EXCLUSIVE);
  
